<template>
  <div id="app" class="container">
    <div class="row">
      <div class="three columns">
        <img src="logo_arslvt.png" alt />
      </div>
      <div class="nine columns">
        <h1>TraceCross</h1>
        <div class="no-print">
          <h6>Cruzamento de utentes do Trace-COVID com listas de inscritos do MIM@UF</h6>
          <small>João Ferreira @ Informática Médica ARS Lisboa e Vale do Tejo</small>
          <br />
          <small>
            <a href="mailto:joao.c.ferreira@arslvt.min-saude.pt">joao.c.ferreira@arslvt.min-saude.pt</a>
          </small>
        </div>
      </div>
    </div>

    <hr />
    <div class="text-center">
      <h3><strong>Aviso</strong></h3>
      <h4>Devido à mais recente alteração da plataforma TraceCOVID, removendo a possibilidade de exportar os utentes nela inscritos, não é possível obter os dados necessários para utilizar esta aplicação a partir de 8 de Abril de 2020.</h4>
      <button class="button no-print" @click="showHelp = !showHelp">{{showHelp ? 'Fechar Ajuda' : 'Ajuda'}}</button>
      <div v-if="showHelp" class="section">
        <div class="u-max-full-width text-left" v-html="markdownHelp"></div>
        <button class="button no-print" @click="showHelp = !showHelp">Fechar Ajuda</button>
      </div>
    </div>
    <div class="section no-print">
      <div class="row">
        <div class="eight columns">
          <h4 class="text-left">Listas dos médicos da Unidade</h4>
        </div>
        <div class="four columns text-right">
          <FilePicker :multiple="true" @newFile="getUsers($event)" />
        </div>
      </div>

      <table class="u-full-width">
        <thead>
          <tr>
            <th>Médico</th>
            <th># utentes</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="user of poolUsers" :key="user">
            <td>{{ user }}</td>
            <td>{{ localPool[user].length }}</td>
          </tr>
        </tbody>
      </table>
    </div>
    <div class="section no-print">
      <div class="row">
        <div class="eight columns">
          <h4 class="text-left">Lista exportada do Trace COVID</h4>
        </div>
        <div class="four columns text-right">
          <FilePicker @newFile="getTrace($event)" />
        </div>
      </div>
    </div>
    <div class="section" :class="{'no-print': showHelp}">
      <div class="row">
        <div class="eight columns">
          <h4 class="text-left">Resultados</h4>
        </div>
        <div class="four columns text-right no-print">
          <button class="button-primary" @click="exportResults">
            <i class="fa fa-upload fa-lg"></i> Exportar
          </button>
        </div>
      </div>

      <TableMatches :matches="matches" />
    </div>
  </div>
</template>

<script>
import FilePicker from "@/components/FilePicker";
import TableMatches from "@/components/TableMatches";
import markdownIt from "markdown-it";
import mdFile from "@/utils/tutorial.md";

import {
  getUsers,
  getTable,
  findTraceMatches,
  toTitleCase,
  exportResults
} from "@/utils/parser";

export default {
  name: "App",
  data() {
    return {
      localPool: {},
      matches: {},
      showHelp: false,
      md: new markdownIt({ html: true })
    };
  },
  components: {
    FilePicker,
    TableMatches
  },
  computed: {
    poolUsers() {
      return Object.keys(this.localPool);
    },
    markdownHelp() {
      return this.md.render(mdFile);
    }
  },
  methods: {
    getUsers(evt) {
      this.$set(this.localPool, toTitleCase(evt.name), getUsers(evt.sheet));
    },
    getTrace(evt) {
      const tracePool = getTable(evt.sheet);
      this.matches = findTraceMatches(this.localPool, tracePool);
    },
    exportResults() {
      exportResults(this.matches);
    }
  }
};
</script>

<style>
#app {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.text-center {
  text-align: center;
}

.text-right {
  text-align: right;
}
.text-left {
  text-align: left;
}

.text-left h1,h2{
  text-align: center;
}

.section {
  background-color: #eee;
  padding: 20px;
  margin: 30px 0px;
  border-radius: 8px;
}

.header {
  max-width: 100% !important;
  box-sizing: border-box;
}

.u-max-full-width img {
  max-width: 100% !important;
  box-sizing: border-box;
}

@media print {
  .no-print {
    display: none
  }
}
</style>
